<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<itemFormativoEsercizio nomeDescrittivo="Servo telecomandato" identificatoreArgomento="esercizio20" prerequisiti="digitalInput" tags="Base,DigitalInput,Software" fondamentale="false" mdPblproblem="false" mdPblnewlearninggoal="false">
    <mdprerequisitelist>I/O digitale</mdprerequisitelist>
    <mdprerequisitelist>Macchina a stati</mdprerequisitelist>
    <mdcomponentlist>Servo con alimentazione a 5V</mdcomponentlist>
    <mdcomponentlist>Ricevitore IR, ad esempio VS1838</mdcomponentlist>
    <mdcomponentlist>Telecomando IR</mdcomponentlist>
    <mdwhy>Introdurre la gestione di eventi validi solo in un particolare intervallo di tempo, quindi una macchina a stati che, in caso di assenza di eventi validi per un certo tempo ritorna allo stato iniziale.</mdwhy>
    <mdexpectedresult>Ricevere e decodificare il segnale del telecomando, far muovere il servo in una direzione o nell'altra in caso di pressione dei i tasti + e -, gestire anche la ripetizione del comando.</mdexpectedresult>
    <mdextras>Aggiungere effetti per gli altri tasti del telecomando, ad esempio abbinare ai numeri una posizione precisa del servo.</mdextras>
    <mderraticbehavior>Il telecomando IR invia come primo segnale il codice corrispondente al tasto premuto e di seguito un codice di ripetizione finché non si rilascia il tasto.&#13;
&#13;
Questo significa che si deve considerare il codice della ripetizione come la ripetizione dell'ultimo tasto premuto (es. regolazione + o - del volume).&#13;
&#13;
La trasmissione del codice però è soggetta ad errori, ad esempio puntando male il telecomando si potrebbe perdere il primo codice e potrebbe poi arrivare solo la ripetizione.&#13;
&#13;
Se non si predispone un un timer che, in assenza di ripetizioni per un certo tempo, riporta l'oggetto in stato di attesa di un nuovo codice tasto, l'evento sopra indicato farà ripetere in caso di errori di trasmissioni l'ultimo comando.</mderraticbehavior>
    <mdcommonerrors>Mancanza del resistore di pullup quando si usa il ricevitore IR da solo e non sul modulo già pronto.</mdcommonerrors>
    <mdlessonlearned>Gestire un tipo di interazione con l'utente senza fili e a basso consumo, con hardware specifico per brevi distanze (telecomando IR e ricevitore IR)&#13;
Trattare correttamente gli errori di comunicazione.</mdlessonlearned>
    <mdsolution>Collegare la linea dati del ricevitore IR al GPIO digitale scelto, collegare il resistore di pullup alla linea dati nel caso sia necessario, ad esempio se si utilizza il ricevitore singolarmente e non su un modulo già assemblato.&#13;
Collegare il GPIO scelto per il servo al relativo pin di input, e l'alimentazione alla sorgente (5v della porta USB o altro alimentatore).</mdsolution>
    <mdpbldetails></mdpbldetails>
</itemFormativoEsercizio>
